tasksController = function () {
  function errorLogger(errorCode, errorMessage) {
    console.log(errorCode + ':' + errorMessage);
  }

  var taskPage;
  var initialised = false;

  return {
    init: function (page, callback) {
        if (initialised) {
          callback()
        }
        else {
          taskPage = page;

          storageEngine.init(function () {
            storageEngine.initObjectStore('task', function () {
              callback();
            }, errorLogger)
          }, errorLogger);

          $(taskPage).find('[required="required"]').prev('label').append('<span>*</span>').children('span').addClass('required');
          $(taskPage).find('tbody tr:even').addClass('even');

          $(taskPage).find('#btnAddTask').click(function (evt) {
            evt.preventDefault();
            $(taskPage).find('#taskCreation').removeClass('not');
          });

          $(taskPage).find('tbody tr').click(function (evt) {
            $(taskPage).find(evt.target).closest('td').siblings().andSelf().toggleClass('rowHighlight');
          });

          $(taskPage).find('#tblTasks tbody').on('click', '.deleteRow', function (evt) {
            evt.preventDefault();
            storageEngine.delete('task', $(evt.target).data().taskId, function () {
              $(evt.target).parents('tr').remove();
            }, errorLogger);
          });

          $(taskPage).find('#tblTasks tbody').on('click', '.editRow', function (evt) {
            $(taskPage).find('#taskCreation').removeClass('not');
            storageEngine.findById('task', $(evt.target).data().taskId, function (task) {
              $(taskPage).find('form').fromObject(task);
            }, errorLogger);
          });

          $(taskPage).find('#saveTask').click(function (evt) {
            evt.preventDefault();
            if ($(taskPage).find('form').valid()) {
              var task = $(taskPage).find('form').toObject();
              storageEngine.save('task', task, function () {
                $(taskPage).find('#tblTasks tbody').empty();
                tasksController.loadTasks();
                $(':input').val('');
                $(taskPage).find('#taskCreation').addClass('not');
              }, errorLogger);
            }
          });

          initialised = true;
        }
    }, loadTasks: function () {
      storageEngine.findAll('task', function (tasks) {
        $.each(tasks, function (index, task) {
          $('#taskRow').tmpl(task).appendTo($(taskPage).find('#tblTasks tbody'));
        });
      }, errorLogger);
    }
  }
}();
